/*********************************************************

PROJECT FILE: main.agc
  by Steve Vink, September 2015
  Use permitted for all purposes, commercial and personal

	This Project is simply to demonstrate the use of the score module
	Do not include this file in your project
	Include only score.agc

// Project: Screen Shake
// Created: 2015-06-25


**********************************************************/

//**********************************************************/
// INCLUDE THIS LINE IN YOUR PROJECT
#include "scores.agc"
//**********************************************************/

global gameState as integer
global tweenUp as integer
global tweenDown as integer
global tweenHit as integer
global arrTarget as float[5,2]
global textSize as integer

// set window properties
	SetWindowTitle( "Scores" )
	SetWindowSize( 1024, 768, 0 )

// set display properties
	SetVirtualResolution( 1024, 768 )
	SetOrientationAllowed( 1, 1, 1, 1 )

//Load the Score Font and create the score text
	font = LoadImage("score.png")
	SetTextDefaultFontImage(font)

	textScore = CreateText("000000")
	textSize = GetVirtualHeight() * 0.25
	SetTextSize(textScore, textSize)
	SetTextAlignment(textScore, 0)
	SetTextPosition(textScore, GetVirtualWidth() / 2 - (GetTextTotalWidth(textScore) / 2), GetVirtualHeight() * 0.2)


//**********************************************************/
//	INCLUDE THIS LINE IN YOUR PROJECT	
//	Initialise the Score System
//**********************************************************/
	scoreInit(5)

score = 0

do

	score = GamePlay()

    if score > 0
		scoreAddPoints(score)
	endif

	//**********************************************************/
	// This line gets the current DISPLAYABLE score
	//**********************************************************/
	score = scoreUpdate()
    
    if score > -1
		score$ = ScoreFormat(score,6)
		SetTextString(textScore, score$)
		SetTextColor(textScore,0,255,0,255)
	else
		SetTextColor(textScore,0,255,255,255)
	endif
	
    Print( ScreenFPS() )
    UpdateAllTweens(GetFrameTime())
    Sync()
loop


//**********************************************************/
// Mini game to demonstrate the score system
//**********************************************************/
function GamePlay()
	
	select gamestate
		
		
		case 0
			// Create Popup tweens
			tweenUp = CreateTweenSprite(1.5)
			tweenDown = CreateTweenSprite(0.5)
			tweenHit = CreateTweenSprite(0.3)
			SetTweenSpriteSizeX(tweenUp,200,200,TweenLinear())
			SetTweenSpriteSizeY(tweenUp,200,200,TweenLinear())
			SetTweenSpriteY(tweenUp,GetVirtualHeight() + 100, GetVirtualHeight() / 2, TweenEaseOut1())
			SetTweenSpriteY(tweenDown, GetVirtualHeight() / 2,GetVirtualHeight() + 100,TweenEaseIn1())
			SetTweenSpriteAlpha(tweenDown,255,0,TweenBounce())
			SetTweenSpriteAlpha(tweenUp,0,255,TweenEaseIn1())
			SetTweenSpriteSizeX(tweenHit,200,500,TweenEaseOut2())
			SetTweenSpriteSizeY(tweenHit,200,500,TweenEaseOut2())
			SetTweenSpriteAlpha(tweenHit,255,0,TweenEaseOut2())
			
			imgTarget = loadimage("target.png")
			for n = 1 to 5
					//Create target
					arrTarget[n,0] = CreateSprite(imgTarget)
					//Set Popup Time
					arrTarget[n,1] = timer() + n
					//Apply a popup
					setPopup(n)
					//Set Sprite Position and size
					SetSpriteSize(arrTarget[n,0],200,200)
					setSpritePosition(arrTarget[n,0],(GetVirtualWidth() * ((n-1)/5.0)),GetVirtualHeight() +100)
			next n
			gamestate = 1
		endcase
		
		case 1
			//Set next start for any targets that are active
			t# = Timer()
			for n = 1 to 5
				if arrTarget[n,1] < t#
					arrTarget[n,1] = timer() + 5 + (random(1,50) / 10.0)
					setPopup(n)
				endif
			next n
		
			//Detect Hits
			if GetPointerReleased()
				hit = GetSpriteHit(GetPointerX(), GetPointerY())
				if hit > 0
					for n = 1 to 5
						if hit = arrTarget[n,0]
							score = score + random(200,500)
							DeleteTweenChain(arrTarget[n,2])
							arrTarget[n,2] = CreateTweenChain()
							AddTweenChainSprite(arrTarget[n,2],tweenHit,arrTarget[n,0],0)
							PlayTweenChain(arrTarget[n,2])
							exit
						endif
					next n
				endif
			endif
		endcase
		
	endselect
	
	
endfunction score

//**********************************************************/
//Creates a tween chain for target movement
//**********************************************************/
function setPopup(sprite)
	
	if arrTarget[sprite,2] > 0
		DeleteTweenChain(arrTarget[sprite,2])
	endif
	
	arrTarget[sprite,2] = CreateTweenChain()
	t# = random(0,30) / 10.0
	AddTweenChainSprite(arrTarget[sprite,2],tweenUp,arrTarget[sprite,0],t#)
	AddTweenChainSprite(arrTarget[sprite,2],tweenDown,arrTarget[sprite,0], 0)
	PlayTweenChain(arrTarget[sprite,2])
	
endfunction
